package compiler;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: An entry in the symbol table for the built in types (int, boolean, String, Object,
 * void and unknown)</p>
 * <p>Copyright: Copyright (c) 2004 Nicholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class TypeSymbol extends Symbol
{
    /**
     * create a new entry in the symbol table for a built in type
     * @param name the type's name
     */
    public TypeSymbol(String name)
    {
        super(name, "void", null);
    }

    //is always OK
    public boolean isResolved()
    {
        return true;
    }

    public boolean symbolEquals(Symbol other)
    {
        if (name.equals("null"))
        {
            if (other instanceof ClassSymbol)
                return true;
            return false;
        }

        if (!(other instanceof TypeSymbol))
            return false;
        return name.equals(((TypeSymbol)other).name);
    }

    public String getKind()
    {
        return "built in type";
    }
}