package test;

import junit.framework.TestCase;
import compiler.*;

/**
 * <p>Title: Programming mini project 2 Java-- compiler</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004 Nicholas Cameron</p>
 * <p>Company: </p>
 * @author Nicholas Cameron
 * @version 1.0
 */

public class TestSymbolTableParent extends TestCase
{
    private SymbolTable st;
    private SymbolTable parent = new SymbolTable();

    public TestSymbolTableParent()
    {
    }

    public void setUp()
    {
        for (int i = 0; i < 5; ++i)
            parent.put(new VariableSymbol("parent" + i, "test", null));
        st = new SymbolTable(parent);
        for (int i = 0; i < 5; ++i)
            st.put(new VariableSymbol("test" + i, "test", null));
    }

    public void testContainsStrict()
    {
        assertFalse("parent3 not in symbol table", st.getStrict("parent3") != null);
    }

    public void testNotContainsStrict()
    {
        assertFalse("parent6 not in symbol table", st.getStrict("parent6") != null);
    }

    public void testContainsNonStrict()
    {
        assertTrue("parent3 in symbol table", st.get("parent3") != null);
    }

    public void testNotContainsNonStrict()
    {
        assertFalse("parent6 not in symbol table", st.get("parent6") != null);
    }

    public void testCanBeDeclared()
    {
        assertFalse(st.canBeDeclared("parent3"));
        assertFalse(st.canBeDeclared("test3"));
    }

    public void testNotCanBeDeclared()
    {
        assertTrue(st.canBeDeclared("test6"));
        assertFalse(st.canBeDeclared("test3"));
    }

    public void testCanBeDeclaredHiding()
    {
        st = new SymbolTable(parent, true);
        for (int i = 0; i < 5; ++i)
            st.put(new VariableSymbol("test" + i, "test", null));

        assertTrue(st.canBeDeclared("parent3"));
        assertFalse(st.canBeDeclared("test3"));
    }

    public void testNotCanBeDeclaredHiding()
    {
        st = new SymbolTable(parent, true);
        for (int i = 0; i < 5; ++i)
            st.put(new VariableSymbol("test" + i, "test", null));

        assertTrue(st.canBeDeclared("test6"));
        assertFalse(st.canBeDeclared("test3"));
    }
}
